// TxLib filesystem functions, filename manipulations, base name
//

#include <txlib.h>                              // TxLib interface


/*****************************************************************************/
// Get base-name part from a path+filename string
/*****************************************************************************/
char *TxGetBaseName                             // RET   ptr to basename
(
   char               *fname                    // IN    path+filename string
)
{
   char               *rc;

   if      ((rc = strrchr( fname, FS_PATH_SEP)) != NULL)
   {
      rc++;                                     // start of basename
   }
   else if ((rc = strrchr( fname, ':')) != NULL) // bare drive spec (x:file)
   {
      rc++;
   }
   else
   {
      rc = fname;                               // no path, use whole name
   }
   return( rc);
}                                               // end 'TxGetBaseName'
/*---------------------------------------------------------------------------*/


/*****************************************************************************/
// Strip basename from path+filename string, leaving the PATH component only
/*****************************************************************************/
char *TxStripBaseName                           // RET   BaseName location,
(                                               //       or NULL if not there
   char               *fname                    // IN    path+filename string
)                                               // OUT   path only string
{
   char               *rc = strrchr( fname, FS_PATH_SEP);

   if (rc != NULL)
   {
      *(rc++) = 0;                              // terminate at PATH_SEP loc
   }                                            // and advance to BaseName
   return( rc);
}                                               // end 'TxStripBaseName'
/*---------------------------------------------------------------------------*/

