// TxLib filesystem functions, filename manipulations, file extension
//

#include <txlib.h>                              // TxLib interface


/*****************************************************************************/
// Append default filename extension to filename, if none present
/*****************************************************************************/
char *TxFnameExtension                          // RET   ptr to filename
(
   char               *fname,                   // INOUT filename string
   char               *ext                      // IN    default extention
)
{
   char               *dot = strrchr( fname, '.');
   char               *sep = strrchr( fname, FS_PATH_SEP);

   if ((dot == NULL) || (dot < sep))            // no extention present
   {
      strcat( fname, ".");
      strcat( fname, ext);
   }
   return( fname);
}                                               // end 'TxFnameExtension'
/*---------------------------------------------------------------------------*/


/*****************************************************************************/
// Remove filename extension from filename, if present
/*****************************************************************************/
char *TxStripExtension                          // RET   ptr to filename
(
   char               *fname                    // INOUT filename string
)
{
   char               *dot = strrchr( fname, '.');
   char               *sep = strrchr( fname, FS_PATH_SEP);

   if (dot > sep)
   {
      *dot = 0;                                 // terminate string at dot
   }
   return( fname);
}                                               // end 'TxStripExtension'
/*---------------------------------------------------------------------------*/

