// Kbhit replacement for IBM C++ multithreaded run-time library
// Avoids wait-for-key when kbhit() is called
//
// Author: J. van Wijk
//
// JvW  27-12-98   Initial version, split off from ansilog.c

#include <txlib.h>

#if defined (DEV32)
int kbhit (void);                               // replacement for kbhit avoids
int kbhit (void)                                // hang with IBMCPP 3.6 runtime
{
   KBDKEYINFO          kbinfo;                  // keyboard info structure
   int                 hit = 0;

   if (KbdPeek( &kbinfo, 0) == NO_ERROR)
   {
      if (kbinfo.fbStatus & 0x40)
      {
         hit = 1;
      }
   }
   return(hit);
}
#endif
