// Generic TX string functions, memory string (not null terminated)
//
// Author: J. van Wijk
//
// JvW  20-08-2005 Initial version, split off from TXSTRING

#include <txlib.h>


/*****************************************************************************/
// Find occurence of a string in a memory region (with embedded NUL)
/*****************************************************************************/
char *TxMemStr                                  // RET   ptr to string or NULL
(
   void               *mem,                     // IN    memory region
   char               *str,                     // IN    string to find
   int                 len                      // IN    length of mem region
)
{
   char               *rc = NULL;
   char               *mr = (char *) mem;
   int                 at = 0;                 // current position from start
   int                 sl = strlen( str);
   char               *hit;

   while ((rc == NULL) && ((hit = memchr( mr + at, str[0], len -at)) != NULL))
   {
      if (strncmp( hit, str, sl) == 0)         // found a match
      {
         rc = hit;
      }
      else
      {
         at = hit - mr +1;
      }
   }
   TRACES(("TxMemStr: mem:%8.8lx, str:'%s' rc:%8.8lx\n", mem, str, rc));
   return (rc);
}                                               // end 'TxMemStr'
/*---------------------------------------------------------------------------*/

