//
// TX string to TX-string-list conversion and handling functions
//
// Author: J. van Wijk
//
// JvW  24-07-2005 Initial version, split off from TXUTIL

#include <txlib.h>


/*****************************************************************************/
// Add string to string-list (allocate memory)
/*****************************************************************************/
char *TxStrListAdd                              // RET   added string
(
   TXSTRLIST         **list,                    // IN    address of list (head)
   char               *str                      // IN    string to add
)
{
   char               *rc = NULL;               // function return
   TXSTRLIST         **elem = list;

   ENTER();

   if (list && str)
   {
      while (*elem != NULL)                     // find end of list
      {
         *elem = (*elem)->next;
      }
      if ((*elem = TxAlloc( 1, sizeof(TXSTRLIST))) != NULL)
      {
         if ((rc = TxAlloc( 1, strlen( str) +1)) != NULL)
         {
            strcpy( rc, str);
            (*elem)->string = rc;
         }
      }
   }
   RETURN (rc);
}                                               // end 'TxStrListAdd'
/*---------------------------------------------------------------------------*/

/*****************************************************************************/
// Free string-list (free memory)
/*****************************************************************************/
void  TxStrListFree
(
   TXSTRLIST         **list                     // IN    address of list (head)
)
{
   TXSTRLIST         **elem;
   TXSTRLIST         **next;

   ENTER();

   for (elem = list; *elem; elem = next)
   {
      next = &(( *elem)->next);
      TxFreeMem( *elem);
   }
   VRETURN();
}                                               // end 'TxStrListFree'
/*---------------------------------------------------------------------------*/

