//
// TX size value to string or TxPrint
//
// Author: J. van Wijk
//
// JvW  24-07-2005 Initial version, split off from TXUTIL

#include <txlib.h>


/*****************************************************************************/
// Format (file) size in 7.1 value + Byte/KiB/MiB/GiB (11); to TxPrint output
/*****************************************************************************/
void txPrtSize64
(
   char               *text,                    // IN    leading string
   LLONG               data,                    // IN    size data
   char               *trail                    // IN    trailing text
)
{
   TXLN                string;

   strcpy( string, "");
   TxPrint("%s", txStrSize64( text, string, data, trail));
}                                               // end 'txPrtSize64'
/*---------------------------------------------------------------------------*/


/*****************************************************************************/
// Format (file) size in 7.1 value + Byte/KiB/MiB/GiB (11); append to string
/*****************************************************************************/
char *txStrSize64                               // RET   resulting string
(
   char               *str,                     // OUT   resulting string
   char               *text,                    // IN    leading string
   LLONG               data,                    // IN    size data
   char               *trail                    // IN    trailing text
)
{
   TXTS                form;

   strcat( str, text);
   if (data <= 99999)                           // express as a byte-value
   {
      sprintf( form, "%5lld bytes", data);
   }
   else                                         // use KiB/MiB/GiB/TiB
   {
      double value = ((double) data) / 1024.0;  // start with KiB

      if      (value <= 4999.9)                 // arbitrary, but 7.8 GiB
      {                                         // works out OK then :-)
         sprintf( form, "%7.1lf KiB", value);   // consistent with DFSee
      }
      else
      {
         value /= 1024.0;                       // convert to MiB
         if (value <= 49999.9)
         {
            sprintf(form, "%7.1lf MiB", value);
         }
         else
         {
            value /= 1024.0;                    // convert to GiB
            if (value <= 49999.9)
            {
               sprintf(form, "%7.1lf GiB", value);
            }
            else
            {
               value /= 1024.0;                 // convert to TiB
               sprintf(form, "%7.1lf TiB", value);
            }
         }
      }
   }
   strcat( str, form);
   strcat( str, trail);
   return( str);
}                                               // end 'txStrSize64'
/*---------------------------------------------------------------------------*/

