//
// Binary value SWAP low/high parts
//
// Author: J. van Wijk
//
// JvW  24-07-2005 Initial version, split off from TXUTIL

#include <txlib.h>


/*****************************************************************************/
// Convert USHORT value from big to little endian or vice-versa
/*****************************************************************************/
USHORT txSwapUS                                 // RET   converted value
(
   USHORT              val                      // IN    value
)
{
   USHORT              rc;

   rc  = (val & 0x00ff) << 8;
   rc += (val & 0xff00) >> 8;

   return (rc);
}                                               // end 'txSwapUS'
/*---------------------------------------------------------------------------*/


/*****************************************************************************/
// Convert ULONG value from big to little endian or vice-versa
/*****************************************************************************/
ULONG txSwapUL                                  // RET   converted value
(
   ULONG               val                      // IN    value
)
{
   ULONG               rc;

   rc  = (val & 0x000000ff) << 24;
   rc += (val & 0x0000ff00) <<  8;
   rc += (val & 0x00ff0000) >>  8;
   rc += (val & 0xff000000) >> 24;

   return (rc);
}                                               // end 'txSwapUL'
/*---------------------------------------------------------------------------*/

